/*
 * PlatformFunctions.hpp
 *
 *  Created on: 17/06/2009
 *      Author: rcamargo
 */

#ifndef PLATFORMFUNCTIONS_HPP_
#define PLATFORMFUNCTIONS_HPP_

#include "Definitions.hpp"

extern "C" {
uint64 gettimeInMilli();
}

struct BenchConfig {
	ucomp printAllVmKernelFinish;
	ucomp printAllSpikeTimes;
	ucomp printSampleVms;

	ucomp assertResultsAll;
	ucomp verbose;
};

struct BenchTimes {

	uint64 start;
	uint64 matrixSetup;
	uint64 execPrepare;
	uint64 execExecution;
	uint64 finish;

	ftype matrixSetupF;
	ftype execPrepareF;
	ftype execExecutionF;
	ftype finishF;

	//-----------------------------------------------------------
	// Used to benchmark the times for each piece of code
	//-----------------------------------------------------------

	uint64 kernelStart;
	uint64 kernelFinish;
	uint64 connRead;
	uint64 connWait;
	uint64 connWrite;

	ftype totalHinesKernel;
	ftype totalConnRead;
	ftype totalConnWait;
	ftype totalConnWrite;

	//-----------------------------------
	ftype meanGenSpikes;
	ftype meanRecSpikes;
	ftype meanGenPyrSpikes;
	ftype meanRecPyrSpikes;
	ftype meanGenInhSpikes;
	ftype meanRecInhSpikes;
};

extern "C" {
extern struct BenchTimes bench;
extern struct BenchConfig benchConf;
}
#endif /* DEFINITIONS_HPP_ */
