# Evaluates the scalability with the number of GPUs
rm -rf speedupA
mkdir speedupA
for i in {1..10}
do
  mkdir speedupA/$i
  for dev in C4 G1 G2 G3 G4
  do
    mkdir speedupA/$i/$dev
    for neurons in 1000 10000 20000 100000 200000
    do
      mkdir speedupA/$i/$dev/$neurons
      mkdir speedupA/$i/$dev/$neurons/s1
      mkdir speedupA/$i/$dev/$neurons/s0
      echo ./HinesGpu ${dev:0:1} $neurons 4 ${dev:1:2} s1 [$i]
      ./HinesGpu ${dev:0:1} $neurons 4 ${dev:1:2} s1 
      mv *.dat speedupA/$i/$dev/$neurons/s1
      echo ./HinesGpu ${dev:0:1} $neurons 4 ${dev:1:2} s0 [$i]
      ./HinesGpu ${dev:0:1} $neurons 4 ${dev:1:2} s0 
      mv *.dat speedupA/$i/$dev/$neurons/s0
    done
  done
  #sleep 300
done

echo
echo

# Evaluates the performance with different number of compartments
rm -rf speedupB
mkdir speedupB
for i in {1..10}
do
  mkdir speedupB/$i
  for comp in 4 8 12 16
  do
    mkdir speedupB/$i/$comp
    for neurons in 1000 10000 20000 100000 200000
    do
      mkdir speedupB/$i/$comp/$neurons
      for dev in G C
      do
        mkdir speedupB/$i/$comp/$neurons/$dev
#       mkdir speedupB/$i/$comp/$neurons/$dev/s1
        mkdir speedupB/$i/$comp/$neurons/$dev/s0

#	echo ./HinesGpu $dev $neurons $comp 4 s1 [$i]
#	./HinesGpu $dev $neurons $comp 4 s1 
#	mv *.dat speedupB/$i/$comp/$neurons/$dev/s1 
	echo ./HinesGpu $dev $neurons $comp 4 s0 [$i]
	./HinesGpu $dev $neurons $comp 4 s0 
	mv *.dat speedupB/$i/$comp/$neurons/$dev/s0
      done
    done
  done
  #sleep 300
done
